<template>
  <b-row>
    <b-col>
      <b-row
          v-if="imagesToShow"
          role="list">
        <b-col
            sm="6"
            md="3"
            lg="2"
            xl="2"
            v-for="(image, index) in imagesToShow"
            role="listitem"
            :key="index">
          <image-viewer :image="image" />
        </b-col>
      </b-row>
      <b-row>
        <b-col
            v-if="loading"
            cols="12">
          <div class="text-center my-4">
            <b-spinner variant="primary" label="Spinning"></b-spinner>
          </div>
        </b-col>
      </b-row>
    </b-col>
  </b-row>
</template>

<script>
import {mapGetters, mapActions} from 'vuex'
import ImageViewer from './ImageViewer'

export default {
  name: 'ImageContainer',
  components: {ImageViewer},
  computed: {
    ...mapGetters({
      imagesToShow: 'gallery/imagesToShow',
      loading: 'gallery/loading',
    })
  },
  methods: {
    ...mapActions({
      incrementPage: 'gallery/incrementPage',
      setImages: 'gallery/setImages'
    }),
    updateImagePageOnPageEnd() {
      if(window.innerHeight + window.scrollY >= document.body.scrollHeight) {
        this.incrementPage()
      }
    }
  },
  created () {
    this.setImages()
    document.addEventListener('scroll', this.updateImagePageOnPageEnd)
  },
  destroyed () {
    document.removeEventListener('scroll', this.updateImagePageOnPageEnd)
  }
}
</script>

<style scoped>

</style>